/*
 *	commudp.h
 *	UDP Ϣ
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#ifndef __ARGS
# define __ARGS
# if defined(__STDC__)	/* NeedFunctionPrototypes */
#  define ARGS(a)	a
# else
#  define ARGS(a)	()
# endif
#endif

#ifndef MAXHOSTNAMELEN
# define MAXHOSTNAMELEN 256
#endif

/* udpcomm.c */
int UdpInit ARGS((int port));
int UdpSend ARGS((struct sockaddr_in *addrp,
			 char *msg, int msglen, int mtu));
int UdpRecv ARGS((struct sockaddr_in *fromp,
			 char *msg, int mru));

/* udpsetup.c */
int UdpSetup ARGS((struct sockaddr_in *addrp));

/* socksetup.c */
int SetSockAddr ARGS((struct sockaddr_in *addrp, char *hname, int port));
