/* mccomm.c  XDR ޤΥƥ */

#include <stdio.h>
#include <stdlib.h>	/* for malloc() */
#include <string.h>	/* for bzero() */
#include <sys/types.h>	/* for type u_char (SunOS 4) */
#include <netinet/in.h>	/* for inet_addr() */
#include <arpa/inet.h>	/* for inet_addr() */

#define MAIN

#include "mc.h"

#define DATASIZE 100
#define STRSIZE 100
#define COUNT 8
#define STRING "This is a sample statement."
#define VARLENSTR "This is a test for packing quoted '\"' string\\."

#define IP_ADDR1 "133.9.68.32"
#define IP_ADDR2 "133.9.68.43"


void main() {
    char *string;
    double data[DATASIZE];
    int ch;
    MCAddr addr1, addr2;
    int i, j;

    /* ǡν */
    for (i = 0; i < COUNT; i++) {
	data[i] = i;
    }

    if (!(string = (char *)malloc(STRSIZE))) {
	exit(1);
    }
    strcpy(string, STRING);

    ch = 'K';

    SetMCAddr(&addr1, MCAF_UDP, NULL, inet_addr(IP_ADDR1), 10005);
    SetMCAddr(&addr2, MCAF_TCP, NULL, inet_addr(IP_ADDR2), 10007);


    /* ʲ饤֥Υƥ */
    InitPack();
    InitUnpack();

    for (j = 0; j < 2; j++) {
	/* pack */
	PackChar(NULL, ch);

	PackHeader(NULL, &addr1, &addr2, 10);

	strcpy(string, VARLENSTR);
	PackVarlenStr(NULL, string);

	AdjSendAlgn();	/* 饤ȹ碌 */
	PackDouble(NULL, data, COUNT);

	strcpy(string, STRING);
	PackStr(NULL, string, strlen(string));


	/* ̿ buffer Ȥ򥳥ԡ */
	ShowSendBuf(stdout);
	_CopyBuffer();
	ShowRecvBuf(stdout);


	/* unpack */
	ch = 0;						/* ꥢ */
	ch = UnpackChar(NULL);
	printf("%c\n", ch);

#ifdef TEST_UNUN
	ch = 0;						/* ꥢ */
	UnUnpackChar();
		/* unpack ϤʤäȤˤ */
	ch = UnpackChar(NULL);
		/* ⤦ unpack */
	printf("%c\n", ch);
#endif

	InitMCAddr(&addr1);  InitMCAddr(&addr2);
	UnpackHeader(NULL, &addr1, &addr2, NULL);
	printf("%s\n", MCAddrNtoA(&addr1));
	printf("%s\n", MCAddrNtoA(&addr2));

	bzero(string, (size_t)STRSIZE);			/* ꥢ */
	UnpackVarlenStr(NULL, string);
	printf("%s\n", string);

	bzero(data, (size_t)COUNT * sizeof(double));	/* ꥢ */
	AdjRecvAlgn();	/* 饤ȹ碌 */
	UnpackDouble(NULL, data, COUNT);
	for (i = 0; i < COUNT; i++)
	    printf("%f\n", data[i]);

	bzero(string, (size_t)STRSIZE);			/* ꥢ */
	UnpackStr(NULL, string, strlen(STRING));
	printf("%s\n", string);

#ifdef TEST_UNUN
	bzero(string, (size_t)STRSIZE);			/* ꥢ */
	UnUnpackStr(strlen(STRING));
		/* unpack ϤʤäȤˤ */
	UnpackStr(NULL, string, strlen(STRING));
		/* ⤦ STRING  unpack */
	printf("%s\n", string);
#endif
    }
}
