#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <netdb.h>

#include "commtcp.h"

#define PORT 10005

#define MESG "hello, I'm server."

int main(argc, argv)
     int argc;
     char **argv;
{
    struct sockaddr me, from;  int nbyte;
    int lsock, sock;
    /* char hname[MAXHOSTNAMELEN];		/* my name */
    char mesg[256];

    strncpy(mesg, MESG, 256);

    if (SetSockAddr((struct sockaddr_in *)&me, NULL, PORT) < 0) {
	exit(1);
    }

    if ((lsock = TcpSetup((struct sockaddr_in *)&me, 5)) < 0) {
	exit(1);
    }

    while (1) {
	if ((sock = accept(lsock, &from, &nbyte)) < 0) {
	    perror("accept");
	    continue;
	}
	write(sock, mesg, 256);
	read(sock, mesg, 256);
	close(sock);
    }
}
